<?php
use CRM_Mjwshared_ExtensionUtil as E;

return [
  [
    'name' => 'SavedSearch_Paymentprocessor_Webhook_Search',
    'entity' => 'SavedSearch',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Paymentprocessor_Webhook_Search',
        'label' => E::ts('Paymentprocessor Webhook Search'),
        'api_entity' => 'PaymentprocessorWebhook',
        'api_params' => [
          'version' => 4,
          'select' => [
            'id',
            'status',
            'created_date',
            'processed_date',
            'payment_processor_id:label',
            'event_id',
            'message',
          ],
          'orderBy' => [],
          'where' => [],
          'groupBy' => [],
          'join' => [],
          'having' => [],
        ],
      ],
      'match' => ['name'],
    ],
  ],
  [
    'name' => 'SavedSearch_Paymentprocessor_Webhook_Search_SearchDisplay_Paymentprocessor_Webhook_Search',
    'entity' => 'SearchDisplay',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Paymentprocessor_Webhook_Search',
        'label' => E::ts('Paymentprocessor Webhook Search'),
        'saved_search_id.name' => 'Paymentprocessor_Webhook_Search',
        'type' => 'table',
        'settings' => [
          'description' => E::ts(NULL),
          'sort' => [
            ['created_date', 'DESC'],
          ],
          'limit' => 50,
          'pager' => [],
          'placeholder' => 5,
          'columns' => [
            [
              'type' => 'field',
              'key' => 'id',
              'dataType' => 'Integer',
              'label' => E::ts('ID'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'status',
              'dataType' => 'String',
              'label' => E::ts('Status'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'created_date',
              'dataType' => 'Timestamp',
              'label' => E::ts('Created Date'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'processed_date',
              'dataType' => 'Timestamp',
              'label' => E::ts('Processed Date'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'payment_processor_id:label',
              'dataType' => 'Integer',
              'label' => E::ts('Payment Processor'),
              'sortable' => TRUE,
              'rewrite' => '[payment_processor_id:label] ([payment_processor_id])',
            ],
            [
              'type' => 'field',
              'key' => 'event_id',
              'dataType' => 'String',
              'label' => E::ts('Event ID'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'message',
              'dataType' => 'String',
              'label' => E::ts('Message'),
              'sortable' => TRUE,
            ],
            [
              'size' => 'btn-xs',
              'links' => [
                [
                  'path' => 'civicrm/paymentprocessorwebhooks/detail#?id=[id]',
                  'icon' => 'fa-clipboard-list',
                  'text' => E::ts('Detail'),
                  'style' => 'default',
                  'condition' => [],
                  'task' => '',
                  'entity' => '',
                  'action' => '',
                  'join' => '',
                  'target' => 'crm-popup',
                ],
                [
                  'task' => 'retry',
                  'entity' => 'PaymentprocessorWebhook',
                  'join' => '',
                  'target' => 'crm-popup',
                  'icon' => 'fa-rectangle-refresh',
                  'text' => E::ts('Retry'),
                  'style' => 'default',
                  'path' => '',
                  'action' => '',
                  'condition' => [],
                ],
                [
                  'task' => 'delete',
                  'entity' => 'PaymentprocessorWebhook',
                  'join' => '',
                  'target' => 'crm-popup',
                  'icon' => 'fa-trash',
                  'text' => E::ts('Delete'),
                  'style' => 'danger',
                  'path' => '',
                  'action' => '',
                  'condition' => [],
                ],
              ],
              'type' => 'buttons',
              'alignment' => 'text-right',
            ],
          ],
          'actions' => TRUE,
          'classes' => ['table', 'table-striped'],
          'actions_display_mode' => 'menu',
          'cssRules' => [
            ['bg-success', 'status', '=', 'success'],
            ['bg-danger', 'status', '=', 'error'],
            ['bg-info', 'status', '=', 'new'],
          ],
          'headerCount' => TRUE,
        ],
      ],
      'match' => [
        'saved_search_id',
        'name',
      ],
    ],
  ],
];
